

// Damian Mehers - see http://bigbird.geo.dec.com/rv/read_vaxmail.html for
// full info - but basically, this is untested, certainly buggy, and
// very much in the experimental stage!



import java.awt.*;
import java.applet.Applet;
import java.net.Socket;
import java.io.*;
import java.io.DataInputStream;

public class AccessVaxmail extends Applet {
    TextArea messageBody;
    List folders, subjects; 
    TextField portId;
    private Socket s;
    private InputStream is;
    private OutputStream os;

    public void init() {

        folders = new List();
	subjects = new List();
	
	messageBody = new TextArea(5, 40);
        messageBody.setEditable(false);
	portId = new TextField("2024");
  
        GridBagLayout gridBag = new GridBagLayout();
        setLayout(gridBag);

        GridBagConstraints tc = new GridBagConstraints();
	tc.fill = GridBagConstraints.BOTH;

        Label label = new Label("Enter the port ID of the mail server and hit enter");
	gridBag.setConstraints(label, tc);
	add(label);
        tc.gridwidth = GridBagConstraints.REMAINDER;
	gridBag.setConstraints(portId, tc);
	add(portId);

	tc.gridwidth = 1;
	tc.weighty = 0.2;
        tc.weightx = 0.1;
        gridBag.setConstraints(folders, tc);
        add(folders);
        tc.weightx = 0.9;
        tc.gridwidth = GridBagConstraints.REMAINDER;
        gridBag.setConstraints(subjects, tc);
        add(subjects);

	tc.weighty = 0.8;
        tc.weightx = 0;
        gridBag.setConstraints(messageBody, tc);
        add(messageBody);

        validate();
    }


    public boolean handleEvent(Event e) {
        if (e.target instanceof List) {
            List list = (List)(e.target);
	    if(e.id == Event.LIST_SELECT) {
		if(list == folders)
                    onFolderSelected(((Integer)e.arg).intValue());
		else
		    onSubjectSelected(((Integer)e.arg).intValue());
            }
        }
        else if (e.id == Event.ACTION_EVENT) {
            if (s != null) {
                try {
                    s.close();
                }
                catch (IOException ioe) {
                    System.err.println("Caught IOException: " + ioe.getMessage());
                }
            }
            s = null;
            System.err.println("Closed the socket");
	    initialiseCommunications();
        }
        return super.handleEvent(e);
    }

    private void initialiseFolders() {
        System.err.println("Initialising Folders");
	folders.clear();
        try {
	    String cmd = "lf";
	    byte[] buf = new byte[cmd.length()];
	    cmd.getBytes(0, cmd.length(), buf, 0);
	    os.write(buf, 0, cmd.length());
	    os.flush();
	    while(true) {
                System.err.println("Waiting for folder");
		int folderLen = is.read();
		if(folderLen == 0)
		    break;
                System.err.println("Got Folder len:");		
		buf = new byte[folderLen];
		is.read(buf, 0, folderLen);
		String folder = new String(buf, folderLen);
                System.err.println("Got Folder:" + folder);
	        folders.addItem(folder);
            }
        }
        catch (IOException e) {
            System.err.println("Caught IOException: " + e.getMessage());
        }
        System.err.println("Initialised Folders");
    }

    private void onFolderSelected(int index) {
        System.err.println("Initialising Subjects for " + folders.getSelectedItem());
        try {
	    String cmd = "sf " + folders.getSelectedItem();
	    byte[] buf = new byte[cmd.length()];
	    cmd.getBytes(0, cmd.length(), buf, 0);
	    os.write(buf, 0, cmd.length());
	    os.flush();
            // Should use subjects.clear() here, but it appears to cause problems ...
	    while(subjects.countItems() > 0)
		subjects.delItem(0);
	    while(true) {
                System.err.println("Waiting for subject");
		int subjectLen = is.read();
		if(subjectLen == 0)
		    break;
		buf = new byte[subjectLen];
		is.read(buf, 0, subjectLen);
		String subject = new String(buf, subjectLen);
                System.err.println("Got Subject:" + subject);
	        subjects.addItem(subject);
            }
        }
        catch (IOException e) {
            System.err.println("Caught IOException: " + e.getMessage());
        }
        System.err.println("Initialised Subjects");
    }
    private void onSubjectSelected(int index) {
        System.err.println("Initialising Text for " + subjects.getSelectedItem());
        try {
	    String cmd = "sm " + String.valueOf(index + 1);
	    byte[] buf = new byte[cmd.length()];
	    cmd.getBytes(0, cmd.length(), buf, 0);
	    os.write(buf, 0, cmd.length());
	    os.flush();
	    messageBody.setText("");
	    while(true) {
                System.err.println("Waiting for text");
		int textLen = is.read();
		if(textLen == 0)
		    break;
		buf = new byte[textLen];
		is.read(buf, 0, textLen);
		String text = new String(buf, textLen);
                System.err.println("Got text:" + text);
	        messageBody.appendText(text);
	        messageBody.appendText("\n");
            }
        }
        catch (IOException e) {
            System.err.println("Caught IOException: " + e.getMessage());
        }
        System.err.println("Initialised text");
    }

    private void initialiseCommunications() {
        System.err.println("Initialising Communications");
        // Should use clear() here, but it appears to cause problems ...
        while(subjects.countItems() > 0)
  	    subjects.delItem(0);
        while(folders.countItems() > 0)
  	    folders.delItem(0);
        messageBody.setText("");
	
	try {
 	    Integer portIdNr = new Integer(portId.getText());
            s = new Socket(getCodeBase().getHost(), portIdNr.intValue(), true);
	    is = s.getInputStream();
            os = s.getOutputStream();
	    initialiseFolders();
        }
        catch (NumberFormatException e) {
            System.err.println("Caught NumberFormatException: " + e.getMessage());
            return;
        }
        catch (IOException e) {
            System.err.println("Caught IOException: " + e.getMessage());
        }
    }

    protected void finalize() {
        if (s != null) {
            try {
                s.close();
            }
            catch (IOException e) {
                System.err.println("Caught IOException: " + e.getMessage());
            }
            s = null;
            System.err.println("Closed the socket");
        }
    }

}
